import { WsApiAction, WsApiRequest, WsApiResponse, WsApiRoute } from '../types';
type WsApiConnection<Action extends WsApiAction, Request extends WsApiRequest<Action>> = {
    disconnect: () => void;
    sendRequest: (request: Request) => void;
};
export type WsApiOptions<Action extends WsApiAction, Request extends WsApiRequest<Action>, Response extends WsApiResponse> = {
    onConnected?: (connection: WsApiConnection<Action, Request>) => void;
    onResponse?: (response: Response, connection: WsApiConnection<Action, Request>) => void;
    onError?: (error: unknown, connection: WsApiConnection<Action, Request>) => void;
    onDisconnected?: () => void;
};
export declare const useWsApi: <Action extends string, Request extends WsApiRequest<Action>, Response extends object>(wsApiUrl: string, route: WsApiRoute<Action, Request, Response> | undefined) => {
    connect: (options: WsApiOptions<Action, Request, Response>) => Promise<void>;
    connected: boolean;
    connection: WsApiConnection<Action, Request>;
    error: boolean;
    disconnect: () => void | undefined;
};
export {};
//# sourceMappingURL=useWsApi.d.ts.map